home | | | faq | | | news | | | download | | | features | | | goals | | | format | | | id | | | comparison | | | documentation | | | changelog | | | links | | | developers

english | | | russian

documentation

This page is broken up into the following sections:

- format - the user-level view of the FLAC format (for a more detailed explanation see the format page).
- flac - the usage of the command-line file encoder/decoder `flac`.
- metaflac - the usage of the command-line FLAC metadata editor `metaflac`.
- plugins - documentation for the various input plugins.
- libFLAC and libFLAC++ APIs - for developers who want to add FLAC support to their programs.
- bugs - known bugs.
- How to add FLAC support to the Monkey's Audio GUI

Keep in mind that the online version of this document will always apply to the latest release. For older releases, check the documentation included with the release package.

format

`flac` has been tuned so that the default options yield a good speed vs. compression tradeoff for many kinds of input. However, if you are looking to maximize the compression rate or speed, or want to use the full power of FLAC's metadata system, this section is for you. If not, just skip to the next section.

The basic structure of a FLAC stream is:

- The four byte string "fLaC"
- The STREAMINFO metadata block
- Zero or more other metadata blocks
- One or more audio frames

The first four bytes are to identify the FLAC stream. The metadata that follows contains all the information about the stream except for the audio data itself. After the metadata comes the encoded audio data.

METADATA

FLAC defines several types of metadata blocks (see the format page for the complete list). Metadata blocks can be any length and new ones can be defined. A decoder is allowed to skip any metadata types it does not understand. Only one is mandatory: the STREAMINFO block. This block has information like the sample rate, number of channels, etc., and data that can help the decoder manage its buffers, like the minimum and maximum data rate and minimum and maximum block size. Also included in the STREAMINFO block is the MD5 signature of the unencoded audio data. This is useful for checking an entire stream for transmission errors.

Other blocks allow for padding, seek tables, tags, cuesheets, and application-specific data. You can see `flac` options below for adding PADDING blocks or specifying seek points. FLAC does not require seek points for seeking but they can speed up seeks, or be used for cueing in editing applications.

Also, if you have a need of a custom metadata block, you can define your own and request an ID here. Then you can reserve a PADDING block of the correct size when encoding, and overwrite the padding block with your APPLICATION block after encoding. The resulting stream will be FLAC compatible; decoders that are aware of your metadata can use it and the rest will safely ignore it.

AUDIO DATA

After the metadata comes the encoded audio data. Audio data and metadata are not interleaved. Like most audio codecs, FLAC splits the unencoded audio data into blocks, and encodes each block separately. The encoded block is packed into a frame and appended to the stream. The reference encoder uses a single block size for the whole stream but the FLAC format does not require it.

BLOCKING

The block size is an important parameter to encoding. If it is too small, the frame overhead will lower the compression. If it is too large, the modeling stage of the compressor will not be able to generate an efficient model. Understanding FLAC's modeling will help you to improve compression for some kinds of input by varying the block size. In the most general case, using linear prediction on 44.1kHz audio, the optimal block size will be between 2-6 ksamples. `flac` defaults to a block size of 4608 in this case. Using the fast fixed predictors, a smaller block size is usually preferable because of the smaller frame header.

INTER-CHANNEL DECORRELATION

In the case of stereo input, once the data is blocked it is optionally passed through an inter-channel decorrelation stage. The left and right channels are converted to center and side channels through the following transformation: mid = (left + right) / 2, side = left - right. This is a lossless process, unlike joint stereo. For normal CD audio this can result in significant extra compression. `flac` has two options for this: `-m` always compresses both the left-right and mid-side versions of the block and takes the smallest frame, and `-M`, which adaptively switches between left-right and mid-side.

MODELING

In the next stage, the encoder tries to approximate the signal with a function in such a way that when the approximation is subracted, the result (called the residual, residue, or error) requires fewer bits-per-sample to encode. The function's parameters also have to be transmitted so they should not be so complex as to eat up the savings. FLAC has two methods of forming approximations: 1) fitting a simple polynomial to the signal; and 2) general linear predictive coding (LPC). I will not go into the details here, only some generalities that involve the encoding options.

First, fixed polynomial prediction (specified with `-l 0`) is much faster, but less accurate than LPC. The higher the maximum LPC order, the slower, but more accurate, the model will be. However, there are diminishing returns with increasing orders. Also, at some point (usually around order 9) the part of the encoder that guesses what is the best order to use will start to get it wrong and the compression will actually decrease slightly; at that point you will have to you will have to use the exhaustive search option `-e` to overcome this, which is significantly slower.

Second, the parameters for the fixed predictors can be transmitted in 3 bits whereas the parameters for the LPC model depend on the bits-per-sample and LPC order. This means the frame header length varies depending on the method and order you choose and can affect the optimal block size.

RESIDUAL CODING

Once the model is generated, the encoder subracts the approximation from the original signal to get the residual (error) signal. The error signal is then losslessly coded. To do this, FLAC takes advantage of the fact that the error signal generally has a Laplacian (two-sided geometric) distribution, and that there are a set of special Huffman codes called Rice codes that can be used to efficiently encode these kind of signals quickly and without needing a dictionary.

Rice coding involves finding a single parameter that matches a signal's distribution, then using that parameter to generate the codes. As the distribution changes, the optimal parameter changes, so FLAC supports a method that allows the parameter to change as needed. The residual can be broken into several contexts or partitions, each with it's own Rice parameter. `flac` allows you to specify how the partitioning is done with the `-r` option. The residual can be broken into 2^n partitions, by using the option `-r n,n`. The parameter n is called the partition order. Furthermore, the encoder can be made to search through m to n partition orders, taking the best one, by specifying `-r m,n`. Generally, the choice of n does not affect encoding speed but m,n does. The larger the difference between m and n, the more time it will take the encoder to search for the best order. The block size will also affect the optimal order.

FRAMING

An audio frame is preceded by a frame header and trailed by a frame footer. The header starts with a sync code, and contains the minimum information necessary for a decoder to play the stream, like sample rate, bits per sample, etc. It also contains the block or sample number and an 8-bit CRC of the frame header. The sync code, frame header CRC, and block/sample number allow resynchronization and seeking even in the absence of seek points. The frame footer contains a 16-bit CRC of the entire encoded frame for error detection. If the reference decoder detects a CRC error it will generate a silent block.

MISCELLANEOUS

As a convenience, the reference decoder knows how to skip ID3v1 and ID3v2 tags. Note however that the FLAC specification does not require compliant implementations to support ID3 in any form and their use is discouraged.

`flac` has a verify option `-V` that verifies the output while encoding. With this option, a decoder is run in parallel to the encoder and its output is compared against the original input. If a difference is found `flac` will stop with an error.

flac

`flac` is the command-line file encoder/decoder. The input to the encoder and the output to the decoder must either be RIFF WAVE format, AIFF, or raw interleaved sample data. `flac` only supports linear PCM samples (in other words, no A-LAW, uLAW, etc.). Another restriction (hopefully short-term) is that the input must be 8, 16, or 24 bits per sample. This is not a limitation of the FLAC format, just the reference encoder/decoder.

`flac` assumes that files ending in ".wav" or that have the RIFF WAVE header present are WAVE files, and files ending in ".aif" or ".aiff" or have the AIFF header present are in AIFF files. This may be overridden with a command-line option. It also assumes that files ending in ".ogg" are Ogg FLAC files. Other than this, `flac` makes no assumptions about file extensions, though the convention is that FLAC files have the extension ".flac" (or ".fla" on ancient file systems like FAT-16).

Before going into the full command-line description, a few other things help to sort it out: 1) `flac` encodes by default, so you must use -d to decode; 2) the options `-0` .. `-8` (or `--fast` and `--best`) that control the compression level actually are just synonyms for different groups of specific encoding options (described later) and you can get the same effect by using the same options; 3) `flac` behaves similarly to gzip in the way it handles input and output files.

`flac` will be invoked one of four ways, depending on whether you are encoding, decoding, testing, or analyzing:

- Encoding: flac [<general-options>] [<format-options>] [<encoding options>] [inputfile [...]]
- Decoding: flac -d [<general-options>] [<format-options>] [<decoding options>] [FLACfile [...]]
- Testing: flac -t [<general-options>] [FLACfile [...]]
- Analyzing: flac -a [<general-options>] [<analysis-options>] [FLACfile [...]]

In any case, if no `inputfile` is specified, stdin is assumed. If only one inputfile is specified, it may be "-" for stdin. When stdin is used as input, `flac` will write to stdout. Otherwise `flac` will perform the desired operation on each input file to similarly named output files (meaning for encoding, the extension will be replaced with ".flac", or appended with ".flac" if the input file has no extension, and for decoding, the extension will be ".wav" for WAVE output and ".raw" for raw output). The original file is not deleted unless --delete-input-file is specified.

If you are encoding/decoding from stdin to a file, you should use the -o option like so:

- flac [options] -o outputfile
- flac -d [options] -o outputfile

which are better than:

- flac [options] > outputfile
- flac -d [options] > outputfile

since the former allows flac to seek backwards to write the STREAMINFO or RIFF WAVE header contents when necessary.

Also, you can force output data to go to stdout using `-c`.

To encode or decode files that start with a dash, use `--` to signal the end of options, to keep the filenames themselves from being treated as options:

- `flac -V -- -01-filename.wav`

The encoding options affect the compression ratio and encoding speed. The format options are used to tell `flac` the arrangement of samples if the input file (or output file when decoding) is a raw file. If it is a RIFF WAVE or AIFF file the format options are not needed since they are read from the AIFF/WAVE header.

In test mode, `flac` acts just like in decode mode, except no output file is written. Both decode and test modes detect errors in the stream, but they also detect when the MD5 signature of the decoded audio does not match the stored MD5 signature, even when the bitstream is valid.

General Options
`-v`, `--version` | Show the `flac` version number.
`-h`, `--help` | Show basic usage and a list of all options. Running `flac` without arguments shows the short help screen by default.
`-H`, `--explain` | Show detailed explanation of usage and all options. Running `flac` without arguments shows the short help screen by default.
`-d`, `--decode` | Decode (`flac` encodes by default). `flac` will exit with an exit code of `1` (and print a message, even in silent mode) if there were any errors during decoding, including when the MD5 checksum does not match the decoded output. Otherwise the exit code will be `0`.
`-t`, `--test` | Test (same as `-d` except no decoded file is written). The exit codes are the same as in decode mode.
`-a`, `--analyze` | Analyze (same as `-d` except an analysis file is written). The exit codes are the same as in decode mode. This option is mainly for developers; the output will be a text file that has data about each frame and subframe.
`-c`, `--stdout` | Write output to stdout.
`-s`, `--silent` | Silent: do not show encoding/decoding statistics.
`--totally-silent` | Do not print anything of any kind, including warnings or errors. The exit code will be the only way to determine successful completion.
`-f`, `--force` | Force overwriting of output files. By default, `flac` warns that the output file already exists and continues to the next file.
`-o filename`, `--output-name=filename` | Force the output file name (usually `flac` just changes the extension). May only be used when encoding a single file. May not be used in conjunction with `--output-prefix`.
`--output-prefix=string` | Prefix each output file name with the given string. This can be useful for encoding/decoding files to a different directory. Make sure if your string is a path name that it ends with a trailing '`/`' slash.
`--delete-input-file` | Automatically delete the input file after a successful encode or decode. If there was an error (including a verify error) the input file is left intact.
`--skip={#|mm:ss.ss}` | Skip over the first # of samples of the input. This works for both encoding and decoding, but not testing. The alternative form `mm:ss.ss` can be used to specify minutes, seconds, and fractions of a second. Examples: `--skip=123` : skip the first 123 samples of the input `--skip=1:23.45` : skip the first 1 minute and 23.45 seconds of the input

`--until={#|[+|-]mm:ss.ss}`

Stop at the given sample number for each input file. This works for both encoding and decoding, but not testing. The given sample number is not included in the decoded output. The alternative form `mm:ss.ss` can be used to specify minutes, seconds, and fractions of a second. If a `+` sign is at the beginning, the `--until` point is relative to the `--skip` point. If a `-` sign is at the beginning, the `--until` point is relative to end of the audio.

Examples:

`--until=123` : decode only the first 123 samples of the input (samples 0-122, stopping at 123)

`--until=1:23.45` : decode only the first 1 minute and 23.45 seconds of the input

`--skip=1:00 --until=+1:23.45` : decode 1:00.00 to 2:23.45

`--until=-1:23.45` : decode everything except the last 1 minute and 23.45 seconds

`--until=-0:00` : decode until the end of the input (the same as not specifying `--until`)

`--ogg`

When encoding, generate Ogg FLAC output instead of native FLAC. Ogg FLAC streams are FLAC streams wrapped in an Ogg transport layer. The resulting file should have an '.ogg' extension and will still be decodable by `flac`.

When decoding, force the input to be treated as Ogg FLAC. This is useful when piping input from stdin or when the filename does not end in '.ogg'.

NOTE: Ogg FLAC files created prior to `flac` 1.1.1 used an ad-hoc mapping and do not support seeking. They should be decoded and re-encoded with `flac` 1.1.1 or later.

`--serial-number=#` | When used with --ogg, specifies the serial number to use for the first Ogg FLAC stream, which is then incremented for each additional stream. When encoding and no serial number is given, `flac` uses a random number for the first stream, then increments it for each additional stream. When decoding and no number is given, `flac` uses the serial number of the first page.

Analysis Options
`--residual-text` | Includes the residual signal in the analysis file. This will make the file very big, much larger than even the decoded file.
`--residual-gnuplot` | Generates a gnuplot file for every subframe; each file will contain the residual distribution of the subframe. This will create a lot of files.

Decoding Options

`--cue=[#.#][-[#.#]]`

Set the beginning and ending cuepoints to decode. The optional first `#.#` is the track and index point at which decoding will start; the default is the beginning of the stream. The optional second `#.#` is the track and index point at which decoding will end; the default is the end of the stream. If the cuepoint does not exist, the closest one before it (for the start point) or after it (for the end point) will be used. If those don't exist, the start of the stream (for the start point) or end of the stream (for the end point) will be used. The cuepoints are merely translated into sample numbers then used as --skip and --until.

Examples:

`--cue=-` : decode the entire stream

`--cue=4.1` : decode from track 4, index 1 to the end of the stream

`--cue=4.1-` : decode from track 4, index 1 to the end of the stream

`--cue=-4.1` : decode from the beginning of the stream up to, but not including, track 4, index 1

`--cue=2.1-2.4` : decode from track 2, index 1, up to, but not including, track 2, index 4

`-F`, `--decode-through-errors` | By default `flac` stops decoding with an error and removes the partially decoded file if it encounters a bitstream error. With `-F`, errors are still printed but `flac` will continue decoding to completion. Note that errors may cause the decoded audio to be missing some samples or have silent sections.

Encoding Options
`-V`, `--verify` | Verify the encoding process. With this option, `flac` will create a parallel decoder that decodes the output of the encoder and compares the result against the original. It will abort immediately with an error if a mismatch occurs. `-V` increases the total encoding time but is guaranteed to catch any unforseen bug in the encoding process.
`--lax` | Allow encoder to generate non-Subset files. The resulting FLAC file may not be streamable or might have trouble being played in all players (especially hardware devices), so you should only use this option in combination with custom encoding options meant for archival.

`--replay-gain`

Calculate ReplayGain values and store in FLAC tags, similar to VorbisGain. Title gains/peaks will be computed for each input file, and an album gain/peak will be computed for all files. All input files must have the same resolution, sample rate, and number of channels. Only mono and stereo files are allowed, and the sample rate must be one of 8, 11.025, 12, 16, 22.05, 24, 32, 44.1, or 48 kHz. Also note that this option may leave a few extra bytes in a PADDING block as the exact size of the tags is not known until all files are processed.

Note that this option cannot be used when encoding to standard output (stdout).

`--cuesheet=FILENAME` | Import the given cuesheet file and store it in a CUESHEET metadata block. This option may only be used when encoding a single file. A seekpoint will be added for each index point in the cuesheet to the SEEKTABLE unless `--no-cued-seekpoints` is specified. The cuesheet file must be of the sort written by CDRwin, CDRcue, EAC, et al.

`--sector-align`

Align encoding of multiple CD format WAVE files on sector boundaries. This option is only allowed when encoding WAVE files, all of which have a 44.1kHz sample rate and 2 channels. With `--sector-align`, the encoder will align the resulting .flac streams so that their lengths are even multiples of a CD sector (1/75th of a second, or 588 samples). It does this by carrying over any partial sector at the end of each WAVE file to the next stream. The last stream will be padded to alignment with zeroes.

This option will have no effect if the files are already aligned (as is the normally the case with WAVE files ripped from a CD). `flac` can only align a set of files given in one invocation of `flac`.

WARNING: The ordering of files is important! If you give a command like '`flac --sector-align *.wav`' the shell may not expand the wildcard to the order you expect. To be safe you should '`echo *.wav`' first to confirm the order, or be explicit like '`flac --sector-align 8.wav 9.wav 10.wav`'.

`-S {#|X|#x|#s}`,
`--seekpoint={#|X|#x|#s}`

Include a point or points in a SEEKTABLE:

- `#` : a specific sample number for a seek point
- `X` : a placeholder point (always goes at the end of the SEEKTABLE)
- `#x` : # evenly spaced seekpoints, the first being at sample 0
- `#s` : a seekpoint every # seconds; # does not have to be a whole number, it can be, for example, `9.5`, meaning a seekpoint every 9.5 seconds

You may use many -S options; the resulting SEEKTABLE will be the unique-ified union of all such values.
With no -S options, flac defaults to '-S 10s'. Use --no-seektable for no SEEKTABLE.
NOTE: -S #x and -S #s will not work if the encoder can't determine the input size before starting.
NOTE: if you use -S # and # is >= samples in the input, there will be either no seek point entered (if the input size is determinable before encoding starts) or a placeholder point (if input size is not determinable).

`-P #`, `--padding=#`

Tell the encoder to write a `PADDING` metadata block of the given length (in bytes) after the `STREAMINFO` block. This is useful if you plan to tag the file later with an `APPLICATION` block; instead of having to rewrite the entire file later just to insert your block, you can write directly over the `PADDING` block. Note that the total length of the `PADDING` block will be 4 bytes longer than the length given because of the 4 metadata block header bytes. You can force no `PADDING` block at all to be written with `--no-padding`. The encoder writes a PADDING block of 4096 bytes by default.

`-T FIELD=VALUE`, `--tag=FIELD=VALUE` | Add a FLAC tag. The comment must adhere to the Vorbis comment spec (which FLAC tags implement), i.e. the FIELD must contain only legal characters, terminated by an 'equals' sign. Make sure to quote the comment if necessary. This option may appear more than once to add several comments. NOTE: all tags will be added to all encoded files.
`-b #`, `--blocksize=#` | Specify the block size in samples. The default is 1152 for -l 0, otherwise 4608. Subset streams must use one of 192/576/1152/2304/4608/256/512/1024/2048/4096/8192/16384/32768. The reference encoder uses the same block size for the entire stream.
`-m`, `--mid-side` | Enable mid-side coding (only for stereo streams). Tends to increase compression by a few percent on average. For each block both the stereo pair and mid-side versions of the block will be encoded, and smallest resulting frame will be stored.
`-M`, `--adaptive-mid-side` | Enable adaptive mid-side coding (only for stereo streams). Like `-m` but the encoder adaptively switches between independent and mid-side coding, which is faster but yields less compression than `-m` (which does an exhaustive search).
`-0 .. -8` | Fastest compression .. highest compression. The default is `-5`.
`-0`, `--compression-level-0` | Synonymous with `-l 0 -b 1152 -r 2,2`
`-1`, `--compression-level-1` | Synonymous with `-l 0 -b 1152 -M -r 2,2`
`-2`, `--compression-level-2` | Synonymous with `-l 0 -b 1152 -m -r 3`
`-3`, `--compression-level-3` | Synonymous with `-l 6 -b 4608 -r 3,3`
`-4`, `--compression-level-4` | Synonymous with `-l 8 -b 4608 -M -r 3,3`
`-5`, `--compression-level-5` | Synonymous with `-l 8 -b 4608 -m -r 3,3`
`-6`, `--compression-level-6` | Synonymous with `-l 8 -b 4608 -m -r 4`
`-7`, `--compression-level-7` | Synonymous with `-l 8 -b 4608 -m -e -r 6`
`-8`, `--compression-level-8` | Synonymous with `-l 12 -b 4608 -m -e -r 6`
`--fast` | Fastest compression. Currently synonymous with `-0`
`--best` | Highest compression. Currently synonymous with `-8`
`-e`, `--exhaustive-model-search` | Exhaustive model search (expensive!). Normally the encoder estimates the best model to use and encodes once based on the estimate. With an exhaustive model search, the encoder will generate subframes for every order and use the smallest. If the max LPC order is high this can significantly increase the encode time but can shave off another 0.5%.
`-l #`, `--max-lpc-order=#` | Specifies the maximum LPC order. This number must be <= 32. If 0, the encoder will not attempt generic linear prediction, and use only fixed predictors. Using fixed predictors is faster but usually results in files being 5-10% larger.
`-q #`, `--qlp-coeff-precision=#` | Specifies the precision of the quantized LP coefficients, in bits. The default is `-q 0`, which means let the encoder decide based on the signal. Unless you really know your input file it's best to leave this up to the encoder.
`-p`, `--qlp-coeff-precision-search` | Do exhaustive LP coefficient quantization optimization. This option overrides any `-q` option. It is expensive and typically will only improve the compression a tiny fraction of a percent. `-q` has no effect when `-l 0` is used.

`-r [#,]#`,
`--rice-partition-order=[#,]#`

Set the [min,]max residual partition order. The min value defaults to 0 if unspecified.

By default the encoder uses a single Rice parameter for the subframe's entire residual. With this option, the residual is iteratively partitioned into 2^min# .. 2^max# pieces, each with its own Rice parameter. Higher values of max# yield diminishing returns. The most bang for the buck is usually with `-r 2,2` (more for higher block sizes). This usually shaves off about 1.5%. The technique tends to peak out about when blocksize/(2^n)=128. Use `-r 0,16` to force the highest degree of optimization.

Format Options
`--endian={big|little}` | Specify big-endian or little-endian byte order in the raw file.
`--channels=#` | Specify the number of channels in the raw file.
`--bps=#` | Specify the number of bits per sample in the raw file.
`--sample-rate=#` | Specify the sample rate of the raw file.
`--sign={signed|unsigned}` | Specify that the samples in the raw file are signed or unsigned (the default is signed).

`--input-size=#`

Specify the size of the raw input in bytes. If you are encoding raw samples from stdin, you must set this option in order to be able to use --skip, --until, --cue-sheet, or other options that need to know the size of the input beforehand. If the size given is greater than what is found in the input stream, the encoder will complain about an unexpected end-of-file. If the size given is less, samples will be truncated.

`--force-aiff-format` | Force the decoder to output AIFF format. This option is not needed if the output filename (as set by -o) ends with .aiff. Also, this option has no effect when encoding since input AIFF is auto-detected.
`--force-raw-format` | Treat the input file (or output file if decoding) as a raw file, regardless of the extension.

Negative Options
`--no-adaptive-mid-side` `--no-decode-through-errors` `--no-delete-input-file` `--no-escape-coding` `--no-exhaustive-model-search` `--no-lax` `--no-mid-side` `--no-ogg` `--no-padding` `--no-qlp-coeff-precision-search` `--no-residual-gnuplot` `--no-residual-text` `--no-sector-align` `--no-seektable` `--no-silent` `--no-verify` | can all be used to turn off a particular option.

metaflac

`metaflac` is the command-line `.flac` file metadata editor. You can use it to list the contents of metadata blocks, edit, delete or insert blocks, and manage padding.

`metaflac` takes a set of "options" (though some are not optional) and a set of FLAC files to operate on. There are three kinds of "options":

- Major operations, which specify a mode of operation like listing blocks, removing blocks, etc. These will have sub-operations describing exactly what is to be done.
- Shorthand operations, which are convenient synonyms for major operations. For example, there is a shorthand operation `--show-sample-rate` that shows just the sample rate field from the STREAMINFO metadata block.
- Global options, which affect all the operations.

All of these are described in the tables below. At least one shorthand or major operation must be supplied. You can use multiple shorthand operations to do more than one thing to a file or set of files. Most of the common things to do to metadata have shorthand operations. As an example, here is how to show the MD5 signatures for a set of three FLAC files:

`metaflac --show-md5sum file1.flac file2.flac file3.flac`

Another example; this removes all DESCRIPTION and COMMENT tags in a set of FLAC files, and uses the `--preserve-modtime` global option to keep the FLAC file modification times the same (usually when files are edited the modification time is set to the current time):

`metaflac --preserve-modtime --remove-tag=DESCRIPTION --remove-tag=COMMENT file1.flac file2.flac file3.flac`

Global Options
`--preserve-modtime` | Preserve the original modification time in spite of edits.
`--with-filename` | Prefix each output line with the FLAC file name (the default if more than one FLAC file is specified).
`--no-filename` | Do not prefix each output line with the FLAC file name (the default if only one FLAC file is specified)
`--no-utf8-convert` | Do not convert tags from UTF-8 to local charset, or vice versa. This is useful for scripts.
`--dont-use-padding` | By default `metaflac` tries to use padding where possible to avoid rewriting the entire file if the metadata size changes. Use this option to tell metaflac to not take advantage of padding this way.

Shorthand Operations
`--show-md5sum` | Show the MD5 signature from the STREAMINFO block.
`--show-min-blocksize` | Show the minimum block size from the STREAMINFO block.
`--show-max-blocksize` | Show the maximum block size from the STREAMINFO block.
`--show-min-framesize` | Show the minimum frame size from the STREAMINFO block.
`--show-max-framesize` | Show the maximum frame size from the STREAMINFO block.
`--show-sample-rate` | Show the sample rate from the STREAMINFO block.
`--show-channels` | Show the number of channels from the STREAMINFO block.
`--show-bps` | Show the # of bits per sample from the STREAMINFO block.
`--show-total-samples` | Show the total # of samples from the STREAMINFO block.
`--show-vendor-tag` | Show the vendor string from the VORBIS_COMMENT block.
`--show-tag=NAME` | Show all tags where the the field name matches `NAME`.
`--remove-tag=NAME` | Remove all tags whose field name is `NAME`.
`--remove-first-tag=NAME` | Remove first tag whose field name is `NAME`.
`--remove-all-tags` | Remove all tags, leaving only the vendor string.
`--set-tag=FIELD` | Add a tag. The `FIELD` must comply with the Vorbis comment spec, of the form `NAME=VALUE`. If there is currently no tag block, one will be created.
`--import-tags-from=FILE` | Import tags from a file. Use '-' for stdin. Each line should be of the form `NAME=VALUE`. Multi-line comments are currently not supported. Specify `--remove-all-tags` and/or `--no-utf8-convert` before `--import-tags-from` if necessary.
`--export-tags-to=FILE` | Export tags to a file. Use '-' for stdin. Each line will be of the form `NAME=VALUE`. Specify `--no-utf8-convert` if necessary.
`--import-cuesheet-from=FILE` | Import a cuesheet from a file. Use '-' for stdin. Only one FLAC file may be specified. A seekpoint will be added for each index point in the cuesheet to the SEEKTABLE unless `--no-cued-seekpoints` is specified.
`--export-cuesheet-to=FILE` | Export CUESHEET block to a cuesheet file, suitable for use by CD authoring software. Use '-' for stdout. Only one FLAC file may be specified on the command line.

`--add-replay-gain`

Calculates the title and album gains/peaks of the given FLAC files as if all the files were part of one album, then stores them in the VORBIS_COMMENT block. The tags are the same as those used by `vorbisgain`. Existing ReplayGain tags will be replaced. If only one FLAC file is given, the album and title gains will be the same. Since this operation requires two passes, it is always executed last, after all other operations have been completed and written to disk. All FLAC files specified must have the same resolution, sample rate, and number of channels. The sample rate must be one of 8, 11.025, 12, 16, 22.05, 24, 32, 44.1, or 48 kHz.

`--add-seekpoint={#|X|#x|#s}`

Add seek points to a SEEKTABLE block:

- `#` : a specific sample number for a seek point
- `X` : a placeholder point (always goes at the end of the SEEKTABLE)
- `#x` : # evenly spaced seekpoints, the first being at sample 0
- `#s` : a seekpoint every # seconds; # does not have to be a whole number, it can be, for example, `9.5`, meaning a seekpoint every 9.5 seconds

If no SEEKTABLE block exists, one will be created. If one already exists, points will be added to the existing table, and any duplicates will be turned into placeholder points.
You may use many `--add-seekpoint` options; the resulting SEEKTABLE will be the unique-ified union of all such values. Example: `--add-seekpoint=100x --add-seekpoint=3.5s` will add 100 evenly spaced seekpoints and a seekpoint every 3.5 seconds.

`--add-padding=#` | Add a padding block of the given length (in bytes). The overall length of the new block will be 4 + length; the extra 4 bytes is for the metadata block header.

Major Operations
`--version` | Show the metaflac version number.

`--list`

List the contents of one or more metadata blocks to stdout. By default, all metadata blocks are listed in text format. Use the following options to change this behavior:

`--block-number=#[,#[...]]`
An optional comma-separated list of block numbers to display. The first block, the STREAMINFO block, is block 0.

`--block-type=type[,type[...]]`
`--except-block-type=type[,type[...]]`
An optional comma-separated list of block types to be included or ignored with this option. Use only one of `--block-type` or `--except-block-type`. The valid block types are: STREAMINFO, PADDING, APPLICATION, SEEKTABLE, VORBIS_COMMENT. You may narrow down the types of APPLICATION blocks displayed as follows:

`APPLICATION:abcd` | The APPLICATION block(s) whose textual representation of the 4-byte ID is "abcd"
`APPLICATION:0xXXXXXXXX` | The APPLICATION block(s) whose hexadecimal big- endian representation of the 4-byte ID is "0xXXXXXXXX". For the example "abcd" above the hexadecimal equivalalent is 0x61626364

NOTE: if both `--block-number` and `--[except-]block-type` are specified, the result is the logical AND of both arguments.

`--application-data-format=hexdump|text`
If the application block you are displaying contains binary data but your `--data-format=text`, you can display a hex dump of the application data contents instead using `--application-data-format=hexdump`.

`--remove`

Remove one or more metadata blocks from the metadata. Unless `--dont-use-padding` is specified, the blocks will be replaced with padding. You may not remove the STREAMINFO block.

`--block-number=#[,#[...]]`
`--block-type=type[,type[...]]`
`--except-block-type=type[,type[...]]`
See `--list` above for usage.

NOTE: if both `--block-number` and `--[except-]block-type` are specified, the result is the logical AND of both arguments.

`--remove-all` | Remove all metadata blocks (except the STREAMINFO block) from the metadata. Unless `--dont-use-padding` is specified, the blocks will be replaced with padding.
`--merge-padding` | Merge adjacent PADDING blocks into single blocks.
`--sort-padding` | Move all PADDING blocks to the end of the metadata and merge them into a single block.

xmms plugin

All that is necessary is to copy `libxmms-flac.so` to the directory where XMMS looks for input plugins (usually `/usr/lib/xmms/Input`). There is nothing else to configure. Make sure to restart XMMS before trying to play any `.flac` files.

winamp2 plugin

The Winamp plugin should work for both Winamp2 and Winamp5. If you are using Winamp 2.x, all that is necessary is to copy `in_flac.dll` to the `Plugins/` directory of your Winamp installation. There is nothing else to configure. Make sure to restart Winamp before trying to play any `.flac` files.

known bugs

Bug tracking is done on the Sourceforge project page here. If you submit a bug, make sure and provide an email contact or use the Monitor feature.

The following are major known bugs in the current (1.1.2) release:

- (none)

The following are major known bugs in the 1.1.0 release:

- If you change the FLAC configuration options in the XMMS plugin while a FLAC file is playing, it can cause a crash or other bad things to happen.

The following are major known bugs in the 1.0.4 release:

- All decoders prior to and including 1.0.4 have a bug that prevents them from skipping unknown metadata blocks properly. A FLAC file created by flac 1.1.0 containing a CUESHEET metadata block will not decode in 1.0.x decoders.
- `metaflac` has a bug where, if --import-vc-from is used on a FLAC file that has no Vorbis comment block, the FLAC file can be corrupted. All FLAC files generated by 1.0.4 have a Vorbis comment block added automatically but files from 1.0.3 and before do not. This is fixed in CVS.
- There is an odd bug in `metaflac` such that you must always use the `--dont-use-padding` option with `--add-padding` or the padding block won't be written. This is fixed in CVS.

monkey

Monkey's Audio comes with a nice GUI that many people are familiar with. It supports some external encoders, but not FLAC. However, the FLAC Windows distribution comes with a utility that allows you to replace one the of the supported lossless external codecs with FLAC. Here's how:

- Copy `flac.exe` and `flac_ren.exe` to the `External/` directory of the Monkey's Audio installation.
- Choose a supported encoder to replace:
  - Shorten - copy `flac_mac.exe` on top of `External/shortn32.exe`
  - WavPack - copy `flac_mac.exe` on top of both `External/wavpack.exe` and `External/wvunpack.exe`
  - RKAU - copy `flac_mac.exe` on top of `External/rkau.exe`
  If you choose WavPack you will also be able to use the WavPack Configuration menu to add flac options.
- Now you can encode FLAC files as if you were using the replaced encoder. The renamed `flac_mac.exe` utility will call `flac.exe` and afterwards, `flac_ren.exe` will rename the resulting file to have the .flac extension.

Other front-ends may be wedged in the same way; if you have one in mind, post it to the flac-dev mailing list.

Copyright (c) 2000,2001,2002,2003,2004,2005 Josh Coalson